In a string S
of lowercase letters, these letters form consecutive groups of the same character.html
For example, a string like S = "abbxxxxzyy"
has the groups "a"
, "bb"
, "xxxx"
, "z"
and "yy"
.post
Call a group large if it has 3 or more characters. We would like the starting and ending positions of every large group.url
The final answer should be in lexicographic order.spa
Example 1:指针
Input: "abbxxxxzzy" Output: [[3,6]] Explanation: large group with starting 3 and ending positions 6. "xxxx" is the single
Example 2:code
Input: "abc" Output: [] Explanation: We have "a","b" and "c" but no large group.
Example 3:orm
Input: "abcdddeeeeaabbbcd" Output: [[3,5],[6,9],[12,14]]
Note: 1 <= S.length <= 1000
htm
这道题给了咱们一个全小写的字符串,说是重复出现的字符能够看成一个群组,若是重复次数大于等于3次,能够看成一个大群组,让咱们找出全部大群组的起始和结束位置。那么实际上就是让咱们计数连续重复字符的出现次数,因为要连续,因此咱们能够使用双指针来作,一个指针指向重复部分的开头,一个日后遍历计数,只要不相同了就中止,而后看次数是否大于等3,是的话就将双指针位置存入结果res中,并更新指针,参见代码以下:blog
解法一:leetcode
class Solution { public: vector<vector<int>> largeGroupPositions(string S) { vector<vector<int>> res; int n = S.size(), i = 0, j = 0; while (j < n) { while (j < n && S[j] == S[i]) ++j; if (j - i >= 3) res.push_back({i, j - 1}); i = j; } return res; } };
咱们也能够换一种写法,不用while循环,而是使用for循环,但本质上仍是双指针的思路,并无什么太大的区别,参见代码以下:
解法二:
class Solution { public: vector<vector<int>> largeGroupPositions(string S) { vector<vector<int>> res; int n = S.size(), start = 0; for (int i = 1; i <= n; ++i) { if (i < n && S[i] == S[start]) continue; if (i - start >= 3) res.push_back({start, i - 1}); start = i; } return res; } };
参考资料:
https://leetcode.com/problems/positions-of-large-groups/
https://leetcode.com/problems/positions-of-large-groups/discuss/128961/Java-Solution-Two-Pointers